

local assets =
{
	Asset("ANIM", "anim/wilson_house_light.zip"),
        Asset("SOUND", "sound/common.fsb"),

}

local prefabs = 
{
	"pigtorch_flame",
}

   local function onnear(inst)
       if inst.components.fueled then
       inst.components.fueled:InitializeFuelLevel(1)    
       end
       if not inst.components.cooker then
       inst:AddComponent("cooker")
       end
       end

   local function onfar(inst)
       if inst.components.cooker then
       inst:RemoveComponent("cooker")
       end
    
       if inst.components.fueled then
       inst.components.burnable:Extinguish()
       end
       end





local function onhammered(inst, worker)
	inst.components.lootdropper:DropLoot()
	--SpawnPrefab("collapse_big").Transform:SetPosition(inst.Transform:GetWorldPosition())
	inst.SoundEmitter:PlaySound("dontstarve/common/destroy_wood")
	inst:Remove()
end

local function onhit(inst, worker)
	inst.AnimState:PlayAnimation("hit")
	inst.AnimState:PushAnimation("idle", true)
end

local function onfinished(inst)
	--inst.AnimState:PlayAnimation("destroy")
	inst:ListenForEvent("animover", function(inst, data) inst:Remove() end)
	inst.SoundEmitter:PlaySound("dontstarve/common/tent_dis_pre")
	inst.persists = false
--inst:DoTaskInTime(16*FRAMES, function() inst.SoundEmitter:PlaySound("dontstarve/common/tent_dis_twirl") end)
end

local function onbuilt(inst)
	inst.AnimState:PlayAnimation("place")
	inst.AnimState:PushAnimation("idle", false)
end


local function onsleep(inst, sleeper)


	if GetClock():IsDay() then
		if sleeper.components.talker then
			sleeper.components.talker:Say(GetString(inst.prefab, "ANNOUNCE_NODAYSLEEP"))
			return
		end
	end
	
	local hounded = GetWorld().components.hounded

	local danger = FindEntity(inst, 10, function(target) return target:HasTag("monster") or target.components.combat and target.components.combat.target == inst end)
	
	if hounded and (hounded.warning or hounded.timetoattack <= 0) then
		danger = true
	end
	
	if danger then
		if sleeper.components.talker then
			sleeper.components.talker:Say(GetString(inst.prefab, "ANNOUNCE_NODANGERSLEEP"))
		end
		return
	end
	
	sleeper.components.health:SetInvincible(true)
	sleeper.components.playercontroller:Enable(false)

	TheFrontEnd:Fade(false,1)

	inst:DoTaskInTime(1.2, function() 
	
		TheFrontEnd:Fade(true,1) 
		
		if GetClock():IsDay() then
			if sleeper.components.talker then				
				sleeper.components.talker:Say(GetString(inst.prefab, "ANNOUNCE_NODAYSLEEP"))
				sleeper.components.health:SetInvincible(false)
				sleeper.components.playercontroller:Enable(true)
				return
			end
		end
		
		if sleeper.components.sanity then
			sleeper.components.sanity:DoDelta(TUNING.SANITY_HUGE)
		end
		
		if sleeper.components.hunger then
			sleeper.components.hunger:DoDelta(-TUNING.CALORIES_HUGE, false, true)
		end
		
		if sleeper.components.health then
			sleeper.components.health:DoDelta(TUNING.HEALING_HUGE, false, "tent", true)
		end
		
		if sleeper.components.tempature then
			sleeper.components.tempature:SetTemperature(sleeper.components.tempature.maxtemp)
		end
		
		
		inst.components.finiteuses:Use()
		GetClock():MakeNextDay()
		
		sleeper.components.health:SetInvincible(false)
		sleeper.components.playercontroller:Enable(true)
		sleeper.sg:GoToState("wakeup")	
	end)
	
	
end	


local function fn(Sim)
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()
	inst:AddTag("tent")    
    
    MakeObstaclePhysics(inst, 1.5)    

    inst:AddTag("structure")
    anim:SetBank("wilson_house_light")
    anim:SetBuild("wilson_house_light")
    anim:PlayAnimation("wilson_house_light", true)
    inst:AddTag("campfire")
	
    local minimap = inst.entity:AddMiniMapEntity()
	minimap:SetIcon( "wilson_house_light.tex" )
	
    --inst:AddComponent("fuel")
    --inst.components.fuel.fuelvalue = 50
    --inst.components.fuel.startsize = "small"
    
    
    inst:AddComponent("inspectable")

    inst:AddComponent("lootdropper")
    inst:AddComponent("workable")
    inst.components.workable:SetWorkAction(ACTIONS.HAMMER)
    inst.components.workable:SetWorkLeft(1)
	inst.components.workable:SetOnFinishCallback(onhammered)
	inst.components.workable:SetOnWorkCallback(onhit)

	inst:AddComponent("finiteuses")
    inst.components.finiteuses:SetMaxUses(500)
    inst.components.finiteuses:SetUses(500)
    inst.components.finiteuses:SetOnFinished( onfinished )
	    
		    
	inst:AddComponent("sleepingbag")
	inst.components.sleepingbag.onsleep = onsleep
	inst:AddComponent("burnable")
	inst.components.burnable:AddBurnFX("pigtorch_flame", Vector3(-210,10,-00.1), "fire_marker")
	
        inst:AddComponent("fueled")
        inst.components.fueled.accepting = false
        inst.components.fueled.maxfuel = 999
        inst.components.fueled:SetSections(1)
          
        inst.components.fueled:SetUpdateFn( function()  
        if GetSeasonManager():IsRaining() then
            inst.components.fueled.rate = 1 + TUNING.PIGTORCH_RAIN_RATE*GetSeasonManager():GetPrecipitationRate()
        else
            inst.components.fueled.rate = 01
        end
        
        if inst.components.burnable and inst.components.fueled then
        inst.components.burnable:SetFXLevel(inst.components.fueled:GetCurrentSection(),                 inst.components.fueled:GetSectionPercent())
        end
    end)
    
        inst.components.fueled:SetSectionCallback( function(section)
        if section == 0 then
            --inst.components.burnable:Extinguish()
        else
            if not inst.components.burnable:IsBurning() then
                inst.components.burnable:Ignite()
            end
            
            inst.components.burnable:SetFXLevel(section, inst.components.fueled:GetSectionPercent())
        end
    end)
    
    
 

inst:AddComponent( "playerprox" )
       inst.components.playerprox:SetDist(10,12)
       inst.components.playerprox:SetOnPlayerNear(onnear)
       inst.components.playerprox:SetOnPlayerFar(onfar)	
       return inst
       end

return Prefab( "wilson_house_light", fn, assets, prefabs),
		MakePlacer( "common/wilson_house_light_placer", "wilson_house_light", "wilson_house_light", "wilson_house_light" ) 
